 package graaf;

/*********************************************************
 * Graafi tipu klass.
 *@author Jri Kiho
 *@version 15.04.2009
*/ 
 public class Tipp {

/**
 * Tipus olev info.
 * Vlja vrtus koosneb kahest osast:
 * <code>nimi = mrgend + koordinaadid</code>
<br>
 * Tipu mrgend ei sisalda thikut, nurksulgu ega semikoolonit. Erijuhul <code>mrgend = ""</code>.
 * Tipu ekraanikoordinaadid <i>x</i> ja <i>y</i> paiknevad nime lpus kujul <code>[x;y]</code>
 * Niteks nimi <code>A[100;80]</code> thendab, et see tipp asub ekraanil kohal 
 * 100, 80 ja tipu mrgendiks on <code>A</code>.
 * Tipuga saab siduda vlju: 
 * vlja kirjeldus paikneb mrgendi alguses kujul snena  
 * <code>vljaNimi=vljaVrtus;</code>
<br>
 * Vlja vrtus antakse snena, mis ei sisalda thikut, nurksulgu ega semikoolonit.
 * Niteks nimi <code>xx=1;y=-2.5;A[100;80]</code> thendab, et see tipp <code>A</code> asub ekraanil kohal 
 * 100, 80 ning sellega on seotud 
 * vli <code>xx</code> (vrtusega <code>1</code>) ja vli <code>y</code> (vrtusega <code>-2.5</code>)
 *
*/   
  private String nimi;

/*****************************
 * Konstruktor.
*/
 public Tipp()
 {
        this.nimi = "[0;0]";
 }

/*****************************
 * Konstruktor.
*/
 public Tipp(String nimi)
 {
        this.nimi = nimi;
 }

/*****************************
 * Piilumeetod.
*/
 public String nimi()
 {
        return nimi;
 }

/*****************************
 * Tipu mrgend.
 * @return Selle tipu mrgend.
*/
 public String mrgend()
 {
        int k = nimi.indexOf("[");
    if (k == -1)
    {
              return nimi;
    }
        return nimi.substring(0, k);
 }

/*****************************
 * Vlja vrtus.
 * @param vljaNimi vlja nimi mille vrtust soovitakse saada
 * @return Vlja vrtus (vi null, kui antud nimega vlja tipul ei ole). 
*/
 public String vli(String vljaNimi)
 {
        int k = nimi.indexOf(vljaNimi + "=");
    if (k == -1)
    {
              return null;
    }
        String tulem = nimi.substring(k + vljaNimi.length() + 1);
        k = tulem.indexOf(";");
    if (k == -1)
    {
              return null;
    }
        return tulem.substring(0, k);
 }

/*****************************
 * Eemaldada vli. Tipult eemaldatakse antud nimega vli (kui selline leidub).
 * @param vljaNimi eemaldatava vlja nimi 
*/
 public void eemaldadaVli(String vljaNimi)
 {
        int k = nimi.indexOf(vljaNimi + "=");
    if (k == -1)
    {
              return;
    }
	String nimiAlgus = nimi.substring(0, k);
        k = nimi.substring(k).indexOf(";");
 //+ vljaNimi.length() + 1
    if (k == -1)
    {
              return; // vli oli ebakorrektne
    }
	nimi = nimiAlgus + nimi.substring(nimiAlgus.length() + k + 1);
 
 }

/*****************************
 * Vlja (ja) vrtuse seadmine. Asendatakse selle tipu vlja vrtus (nime osa, mis paikneb
 * "vljaNimi=" ja semikooloni vahel) antud vrtusega. Kui sellist vlja veel ei olnud, siis 
 * see lisatakse sellele tipule (nime algusse) koos antud vrtusega.
 * @param vljaNimi vlja nimi millele soovitakse anda uus vrtus
 * @param vljaVrtus omistatav vrtus 
*/
 public void seadaVli(String vljaNimi, String vljaVrtus)
 {
         // Tulemus: 
        int k = nimi.indexOf(vljaNimi + "=");
    if (k == -1)
    {
              nimi = vljaNimi + "="+  vljaVrtus + ";" + nimi;
              return;
    }
        String algusosa = nimi.substring(0, k + vljaNimi.length() + 1);
        String lpuosa = nimi.substring(k + vljaNimi.length() + 1);
        k = lpuosa.indexOf(";");
    if (k == -1)
    {
              return; // viga
    }
        lpuosa = lpuosa.substring(k);
        
        nimi =  algusosa + vljaVrtus + lpuosa;
 }

/*****************************
 * Nime omistamine. Antud nimi omistatakse sellele tipule.
 * @param nimi omistatav nimi
*/
 public void seadaNimi(String nimi)
 {
        this.nimi = nimi;
 }

/*****************************
 * Mrgendi omistamine. Antud mrgend omistatakse sellele tipule.
 * @param s omistatav mrgend
*/
 public void seadaMrgend(String s)
 {
         // Antud: sne s
         // Tulemus: nimes asendatud mrgend sneg s
        int k = nimi.indexOf("[");
    if (k == -1)
    {
              seadaNimi(s);
    }
    else
    {
              seadaNimi(s + nimi.substring(k));
    }
 }

/*****************************
 * Koordinaatide omistamine. Antud koordinaadid omistatakse sellele tipule.
 * @param x selle tipu uus x-koordinaat
 * @param y selle tipu uus y-koordinaat
*/
 public void seadaKoordinaadid(int x, int y)
 {
         // Antud: tipp t ja (uued) koordinaadid
         // Tulemus: nimes asendatud [x;y]
        String s = nimi;
        int k = nimi.indexOf("[");
    if (k != -1)
    {
              s = nimi.substring(0, k);
    }
        nimi = s + "[" + x + ";" + y + "]";
 }

/*****************************
 * Tipu abstsiss. 
 * @return Selle tipu x-koordinaat. 
*/
 public int x()
 {
         // Tulemus: selle tipu x (nimest ... [x;y])
        int k = nimi.indexOf("[");
        String s = nimi.substring(k+1);
        k = s.indexOf(";");
        s = s.substring(0, k);
        return Integer.parseInt(s);
 }

/*****************************
 * Tipu ordinaat. 
 * @return Selle tipu y-koordinaat. 
*/
 public int y()
 {
         // Tulemus: selle tipu y (nimest ... [x;y])
        int k = nimi.indexOf("[");
        String s = nimi.substring(k+1);
        k = s.indexOf(";");
        int k1 = s.indexOf("]");
        s = s.substring(k+1, k1);
        return Integer.parseInt(s);
 }
 }
